%
% Copyright (c) 2005 Carnegie Mellon University.  All rights
% reserved.
%
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions
% are met:
%
% 1. Redistributions of source code must retain the above copyright
%    notice, this list of conditions and the following disclaimer.
%
% 2. Redistributions in binary form must reproduce the above copyright
%    notice, this list of conditions and the following disclaimer in
%    the documentation and/or other materials provided with the
%    distribution.
%
% 3. The end-user documentation included with the redistribution,
%    if any, must include the following acknowledgment:
%       "This product includes software developed by
%        Carnegie Mellon University (http://www.cmu.edu/)."
%    Alternately, this acknowledgment may appear in the software itself,
%    if and wherever such third-party acknowledgments normally appear.
%
% 4. The names "Carnegie Mellon University" and "CMU" must
%    not be used to endorse or promote products derived from this
%    software.
%
% 5. Products derived from this software may not be called
%     "Carnegie Mellon University" or "CMU",
%    nor may "Carnegie Mellon University"  or "CMU" appear in their name.
%
% THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
% WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
% OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
% ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
% SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
% LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
% USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
% ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
% OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
% OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
% SUCH DAMAGE.
%
% @ProposedRating yellow jingcao@ece.cmu.edu
%

function [x,y,dir] = select_channel(lambda, mu)
%select_channel(lambda,mu)

global b;

min_mu_eff = 10;

dimension = size(mu);
num_of_rows = dimension(1);
num_of_cols = dimension(2);
num_of_dirs = dimension(3);

mu_eff = ones(num_of_rows, num_of_cols, num_of_dirs);

%% ro value calculation
%% old implementation
% for i = 1 : num_of_rows
%   for j = 1 : num_of_cols
%     for k = 1 : num_of_dirs
%       ro(i,j,k) = lambda(i,j,k) / mu(i,j,k);
%       if k == 1 | b(i,j,k) == 0
%         mu_eff(i,j,k) = 1;
%       else
%         mu_eff(i,j,k) = (1 - ro(i,j,k)^b(i,j,k)) / (1 - ro(i,j,k)^(b(i,j,k) + 1));
%         if mu_eff(i,j,k) < min_mu_eff
%           x = i;
%           y = j;
%           dir = k;
%           min_mu_eff = mu_eff(i,j,k);
%         end
%       end
%     end
%   end
% end


% new implementation
diff = -1;
max_diff = -1;
for i = 1 : num_of_rows
  for j = 1 : num_of_cols
    for k = 1 : num_of_dirs
      ro(i,j,k) = lambda(i,j,k) / mu(i,j,k);
      if k == 1 | b(i,j,k) == 0
        diff = -1;
      else
        diff = lambda(i,j,k) - (1 - ro(i,j,k)^b(i,j,k)) / (1 - ro(i,j,k)^(b(i,j,k) + 1));
        if diff > max_diff
          x = i;
          y = j;
          dir = k;
          max_diff = diff;
        end
      end
    end
  end
end
    
